# Interface LenientConfiguration

public interface LenientConfiguration
Resolved configuration that does not fail eagerly when some dependencies are not resolved, or some artifacts do not exist.

This is a legacy API. Avoid this class for new code. Lenient artifacts can be acquired through a `lenient ArtifactView`. This API will be deprecated and removed in future Gradle versions.

- This class is not configuration-cache compatible.
- Returned file sets do not track task dependencies.
- The returned types do not reflect the variant-aware nature of the dependency resolution engine.

Since:
  1.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Set<ResolvedDependency>`
  `getAllModuleDependencies()`
  Returns all successfully resolved dependencies including transitive dependencies.
  `Set<ResolvedArtifact>`
  `getArtifacts()`
  Gets successfully resolved artifacts.
  `Set<ResolvedDependency>`
  `getFirstLevelModuleDependencies()`
  Returns successfully resolved direct dependencies.
  `Set<UnresolvedDependency>`
  `getUnresolvedModuleDependencies()`
  returns dependencies that were attempted to resolve but failed.

- ## Method Details

  - ### getFirstLevelModuleDependencies

    Set<ResolvedDependency> getFirstLevelModuleDependencies()
    Returns successfully resolved direct dependencies.

    Prefer `ResolutionResult` for traversing the resolved graph or `ArtifactView.getArtifacts()` for accessing the resolved artifacts.

    Returns:
      only resolved dependencies
    Since:
      3.3

  - ### getAllModuleDependencies

    Set<ResolvedDependency> getAllModuleDependencies()
    Returns all successfully resolved dependencies including transitive dependencies.

    Prefer `ResolutionResult` for traversing the resolved graph or `ArtifactView.getArtifacts()` for accessing the resolved artifacts.

    Returns:
      all resolved dependencies
    Since:
      3.1

  - ### getUnresolvedModuleDependencies

    Set<UnresolvedDependency> getUnresolvedModuleDependencies()
    returns dependencies that were attempted to resolve but failed. If empty then all dependencies are neatly resolved.

    Prefer `ResolutionResult`.

    Returns:
      only unresolved dependencies
    Since:
      1.0

  - ### getArtifacts

    Set<ResolvedArtifact> getArtifacts()
    Gets successfully resolved artifacts. Ignores dependencies or files that cannot be resolved.

    Prefer `ArtifactView.getArtifacts()`.

    Returns:
      successfully resolved artifacts
    Since:
      3.3